/*
 * The contents of this file are subject to the Mozilla Public License Version 1.1
 * (the "License"); you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://www.mozilla.org/MPL/>.
 * 
 * Software distributed under the License is distributed on an "AS IS" basis, WITHOUT
 * WARRANTY OF ANY KIND, either express or implied. See the License for the specific
 * language governing rights and limitations under the License.
 * 
 * The Original Code is the Venice Web Communities System.
 * 
 * The Initial Developer of the Original Code is Eric J. Bowersox <erbo@silcom.com>,
 * for Silverwrist Design Studios.  Portions created by Eric J. Bowersox are
 * Copyright (C) 2003 Eric J. Bowersox/Silverwrist Design Studios.  All Rights Reserved.
 * 
 * Contributor(s): 
 */
package com.silverwrist.dynamo.dialog;

import java.util.*;
import org.w3c.dom.Element;
import com.silverwrist.util.*;
import com.silverwrist.dynamo.except.DialogException;

class LocaleListField extends PickListField
{
  /*--------------------------------------------------------------------------------
   * Constructors
   *--------------------------------------------------------------------------------
   */

  LocaleListField(Element elt) throws DialogException
  {
    super(elt);

  } // end constructor

  protected LocaleListField(LocaleListField other)
  {
    super(other);

  } // end constructor

  /*--------------------------------------------------------------------------------
   * Abstract implementations from class BaseDialogField
   *--------------------------------------------------------------------------------
   */

  public Object clone()
  {
    return new LocaleListField(this);

  } // end clone

  /*--------------------------------------------------------------------------------
   * Abstract implementations from class PickListField
   *--------------------------------------------------------------------------------
   */

  protected Iterator getChoices()
  {
    return Arrays.asList(Locale.getAvailableLocales()).iterator();

  } // end getChoices

  protected String getChoiceName(Object choice)
  {
    return choice.toString();

  } // end getChoiceName

  protected String getChoiceDisplay(Object choice)
  {
    return ((Locale)choice).getDisplayName();

  } // end getChoiceDisplay

  protected Object getChoiceForName(String name)
  {
    return International.get().createLocale(name);

  } // end getChoiceForName

  protected boolean isValidChoice(Object choice)
  {
    return (choice instanceof Locale);

  } // end isValidChoice

} // end class LocaleListField
